Index: ntoskrnl/mm/rmap.c
===================================================================
--- ntoskrnl/mm/rmap.c	(revision 21808)
+++ ntoskrnl/mm/rmap.c	(working copy)
@@ -62,7 +62,7 @@
    PMADDRESS_SPACE AddressSpace;
    ULONG Type;
    PVOID Address;
-   PEPROCESS Process;
+   PROS_EPROCESS Process;
    PMM_PAGEOP PageOp;
    ULONG Offset;
    NTSTATUS Status = STATUS_SUCCESS;
@@ -78,7 +78,7 @@
       ExReleaseFastMutex(&RmapListLock);
       return(STATUS_UNSUCCESSFUL);
    }
-   Process = entry->Process;
+   Process = (PROS_EPROCESS)entry->Process;
    Address = entry->Address;
    if ((((ULONG_PTR)Address) & 0xFFF) != 0)
    {
@@ -196,7 +196,7 @@
    PMADDRESS_SPACE AddressSpace;
    ULONG Type;
    PVOID Address;
-   PEPROCESS Process;
+   PROS_EPROCESS Process;
    PMM_PAGEOP PageOp;
    ULONG Offset;
    NTSTATUS Status = STATUS_SUCCESS;
@@ -208,7 +208,7 @@
       ExReleaseFastMutex(&RmapListLock);
       return(STATUS_UNSUCCESSFUL);
    }
-   Process = entry->Process;
+   Process = (PROS_EPROCESS)entry->Process;
    Address = entry->Address;
    if ((((ULONG_PTR)Address) & 0xFFF) != 0)
    {
@@ -326,7 +326,7 @@
    }
    while (current_entry != NULL)
    {
-      MmSetCleanPage(current_entry->Process, current_entry->Address);
+      MmSetCleanPage((PROS_EPROCESS)current_entry->Process, current_entry->Address);
       current_entry = current_entry->Next;
    }
    ExReleaseFastMutex(&RmapListLock);
@@ -347,7 +347,7 @@
    }
    while (current_entry != NULL)
    {
-      MmSetDirtyPage(current_entry->Process, current_entry->Address);
+      MmSetDirtyPage((PROS_EPROCESS)current_entry->Process, current_entry->Address);
       current_entry = current_entry->Next;
    }
    ExReleaseFastMutex(&RmapListLock);
@@ -368,7 +368,7 @@
    }
    while (current_entry != NULL)
    {
-      if (MmIsDirtyPage(current_entry->Process, current_entry->Address))
+      if (MmIsDirtyPage((PROS_EPROCESS)current_entry->Process, current_entry->Address))
       {
          ExReleaseFastMutex(&RmapListLock);
          return(TRUE);
@@ -381,7 +381,7 @@
 
 VOID
 NTAPI
-MmInsertRmap(PFN_TYPE Page, PEPROCESS Process,
+MmInsertRmap(PFN_TYPE Page, PROS_EPROCESS Process,
              PVOID Address)
 {
    PMM_RMAP_ENTRY current_entry;
@@ -396,7 +396,7 @@
       KEBUGCHECK(0);
    }
    new_entry->Address = Address;
-   new_entry->Process = Process;
+   new_entry->Process = (PEPROCESS)Process;
 #ifdef DBG
    new_entry->Caller = __builtin_return_address(0);
 #endif   
@@ -433,7 +433,7 @@
    ExReleaseFastMutex(&RmapListLock);
    if (Process == NULL)
    {
-      Process = PsInitialSystemProcess;
+      Process = (PROS_EPROCESS)PsInitialSystemProcess;
    }
    if (Process)
    {
@@ -448,7 +448,7 @@
 VOID
 NTAPI
 MmDeleteAllRmaps(PFN_TYPE Page, PVOID Context,
-                 VOID (*DeleteMapping)(PVOID Context, PEPROCESS Process,
+                 VOID (*DeleteMapping)(PVOID Context, PROS_EPROCESS Process,
                                        PVOID Address))
 {
    PMM_RMAP_ENTRY current_entry;
@@ -470,7 +470,7 @@
       current_entry = current_entry->Next;
       if (DeleteMapping)
       {
-         DeleteMapping(Context, previous_entry->Process,
+         DeleteMapping(Context, (PROS_EPROCESS)previous_entry->Process,
                        previous_entry->Address);
       }
       Process = previous_entry->Process;
@@ -488,7 +488,7 @@
 
 VOID
 NTAPI
-MmDeleteRmap(PFN_TYPE Page, PEPROCESS Process,
+MmDeleteRmap(PFN_TYPE Page, PROS_EPROCESS Process,
              PVOID Address)
 {
    PMM_RMAP_ENTRY current_entry, previous_entry;
@@ -498,7 +498,7 @@
    current_entry = MmGetRmapListHeadPage(Page);
    while (current_entry != NULL)
    {
-      if (current_entry->Process == Process &&
+      if (current_entry->Process == (PEPROCESS)Process &&
             current_entry->Address == Address)
       {
          if (previous_entry == NULL)
@@ -513,7 +513,7 @@
          ExFreeToNPagedLookasideList(&RmapLookasideList, current_entry);
 	 if (Process == NULL)
 	 {
-	    Process = PsInitialSystemProcess;
+	    Process = (PROS_EPROCESS)PsInitialSystemProcess;
 	 }
 	 if (Process)
 	 {
Index: ntoskrnl/mm/i386/page.c
===================================================================
--- ntoskrnl/mm/i386/page.c	(revision 21808)
+++ ntoskrnl/mm/i386/page.c	(working copy)
@@ -203,7 +203,7 @@
 
 NTSTATUS
 NTAPI
-Mmi386ReleaseMmInfo(PEPROCESS Process)
+Mmi386ReleaseMmInfo(PROS_EPROCESS Process)
 {
    PUSHORT LdtDescriptor;
    ULONG LdtBase;
@@ -329,8 +329,8 @@
 
 NTSTATUS
 STDCALL
-MmCopyMmInfo(PEPROCESS Src,
-             PEPROCESS Dest,
+MmCopyMmInfo(PROS_EPROCESS Src,
+             PROS_EPROCESS Dest,
              PPHYSICAL_ADDRESS DirectoryTableBase)
 {
    NTSTATUS Status;
@@ -408,9 +408,9 @@
 
 VOID
 NTAPI
-MmDeletePageTable(PEPROCESS Process, PVOID Address)
+MmDeletePageTable(PROS_EPROCESS Process, PVOID Address)
 {
-   PEPROCESS CurrentProcess = PsGetCurrentProcess();
+   PROS_EPROCESS CurrentProcess = (PROS_EPROCESS)PsGetCurrentProcess();
 
    if (Process != NULL && Process != CurrentProcess)
    {
@@ -441,9 +441,9 @@
 
 VOID
 NTAPI
-MmFreePageTable(PEPROCESS Process, PVOID Address)
+MmFreePageTable(PROS_EPROCESS Process, PVOID Address)
 {
-   PEPROCESS CurrentProcess = PsGetCurrentProcess();
+   PROS_EPROCESS CurrentProcess = (PROS_EPROCESS)PsGetCurrentProcess();
    ULONG i;
    PFN_TYPE Pfn;
 
@@ -504,7 +504,7 @@
 }
 
 static PULONGLONG
-MmGetPageTableForProcessForPAE(PEPROCESS Process, PVOID Address, BOOLEAN Create)
+MmGetPageTableForProcessForPAE(PROS_EPROCESS Process, PVOID Address, BOOLEAN Create)
 {
    NTSTATUS Status;
    PFN_TYPE Pfn;
@@ -520,7 +520,7 @@
    {
       KEBUGCHECK(0);
    }
-   if (Address < MmSystemRangeStart && Process && Process != PsGetCurrentProcess())
+   if (Address < MmSystemRangeStart && Process && Process != (PROS_EPROCESS)PsGetCurrentProcess())
    {
       PageDirTable = MmCreateHyperspaceMapping(PAE_PTE_TO_PFN(Process->Pcb.DirectoryTableBase.QuadPart));
       if (PageDirTable == NULL)
@@ -618,7 +618,7 @@
 }
 
 static PULONG
-MmGetPageTableForProcess(PEPROCESS Process, PVOID Address, BOOLEAN Create)
+MmGetPageTableForProcess(PROS_EPROCESS Process, PVOID Address, BOOLEAN Create)
 {
    ULONG PdeOffset = ADDR_TO_PDE_OFFSET(Address);
    NTSTATUS Status;
@@ -626,7 +626,7 @@
    ULONG Entry;
    PULONG Pt, PageDir;
 
-   if (Address < MmSystemRangeStart && Process && Process != PsGetCurrentProcess())
+   if (Address < MmSystemRangeStart && Process && Process != (PROS_EPROCESS)PsGetCurrentProcess())
    {
       PageDir = MmCreateHyperspaceMapping(PTE_TO_PFN(Process->Pcb.DirectoryTableBase.QuadPart));
       if (PageDir == NULL)
@@ -736,7 +736,7 @@
    return FALSE;
 }
 
-static ULONGLONG MmGetPageEntryForProcessForPAE(PEPROCESS Process, PVOID Address)
+static ULONGLONG MmGetPageEntryForProcessForPAE(PROS_EPROCESS Process, PVOID Address)
 {
    ULONGLONG Pte;
    PULONGLONG Pt;
@@ -751,7 +751,7 @@
    return 0;
 }
 
-static ULONG MmGetPageEntryForProcess(PEPROCESS Process, PVOID Address)
+static ULONG MmGetPageEntryForProcess(PROS_EPROCESS Process, PVOID Address)
 {
    ULONG Pte;
    PULONG Pt;
@@ -768,7 +768,7 @@
 
 PFN_TYPE
 NTAPI
-MmGetPfnForProcess(PEPROCESS Process,
+MmGetPfnForProcess(PROS_EPROCESS Process,
                    PVOID Address)
 {
 
@@ -796,7 +796,7 @@
 
 VOID
 NTAPI
-MmDisableVirtualMapping(PEPROCESS Process, PVOID Address, BOOLEAN* WasDirty, PPFN_TYPE Page)
+MmDisableVirtualMapping(PROS_EPROCESS Process, PVOID Address, BOOLEAN* WasDirty, PPFN_TYPE Page)
 /*
  * FUNCTION: Delete a virtual mapping
  */
@@ -916,7 +916,7 @@
 
 VOID
 NTAPI
-MmDeleteVirtualMapping(PEPROCESS Process, PVOID Address, BOOLEAN FreePage,
+MmDeleteVirtualMapping(PROS_EPROCESS Process, PVOID Address, BOOLEAN FreePage,
                        BOOLEAN* WasDirty, PPFN_TYPE Page)
 /*
  * FUNCTION: Delete a virtual mapping
@@ -1060,7 +1060,7 @@
 
 VOID
 NTAPI
-MmDeletePageFileMapping(PEPROCESS Process, PVOID Address,
+MmDeletePageFileMapping(PROS_EPROCESS Process, PVOID Address,
                         SWAPENTRY* SwapEntry)
 /*
  * FUNCTION: Delete a virtual mapping
@@ -1199,7 +1199,7 @@
 
 BOOLEAN
 NTAPI
-MmIsDirtyPage(PEPROCESS Process, PVOID Address)
+MmIsDirtyPage(PROS_EPROCESS Process, PVOID Address)
 {
    if (Ke386Pae)
    {
@@ -1213,7 +1213,7 @@
 
 BOOLEAN
 NTAPI
-MmIsAccessedAndResetAccessPage(PEPROCESS Process, PVOID Address)
+MmIsAccessedAndResetAccessPage(PROS_EPROCESS Process, PVOID Address)
 {
    if (Address < MmSystemRangeStart && Process == NULL)
    {
@@ -1280,7 +1280,7 @@
 
 VOID
 NTAPI
-MmSetCleanPage(PEPROCESS Process, PVOID Address)
+MmSetCleanPage(PROS_EPROCESS Process, PVOID Address)
 {
    if (Address < MmSystemRangeStart && Process == NULL)
    {
@@ -1345,7 +1345,7 @@
 
 VOID
 NTAPI
-MmSetDirtyPage(PEPROCESS Process, PVOID Address)
+MmSetDirtyPage(PROS_EPROCESS Process, PVOID Address)
 {
    if (Address < MmSystemRangeStart && Process == NULL)
    {
@@ -1406,7 +1406,7 @@
 
 VOID
 NTAPI
-MmEnableVirtualMapping(PEPROCESS Process, PVOID Address)
+MmEnableVirtualMapping(PROS_EPROCESS Process, PVOID Address)
 {
    if (Ke386Pae)
    {
@@ -1462,7 +1462,7 @@
 
 BOOLEAN
 NTAPI
-MmIsPagePresent(PEPROCESS Process, PVOID Address)
+MmIsPagePresent(PROS_EPROCESS Process, PVOID Address)
 {
    if (Ke386Pae)
    {
@@ -1476,7 +1476,7 @@
 
 BOOLEAN
 NTAPI
-MmIsPageSwapEntry(PEPROCESS Process, PVOID Address)
+MmIsPageSwapEntry(PROS_EPROCESS Process, PVOID Address)
 {
    if (Ke386Pae)
    {
@@ -1622,7 +1622,7 @@
 
 NTSTATUS
 NTAPI
-MmCreatePageFileMapping(PEPROCESS Process,
+MmCreatePageFileMapping(PROS_EPROCESS Process,
                         PVOID Address,
                         SWAPENTRY SwapEntry)
 {
@@ -1710,7 +1710,7 @@
 
 NTSTATUS
 NTAPI
-MmCreateVirtualMappingUnsafe(PEPROCESS Process,
+MmCreateVirtualMappingUnsafe(PROS_EPROCESS Process,
                              PVOID Address,
                              ULONG flProtect,
                              PPFN_TYPE Pages,
@@ -1916,7 +1916,7 @@
 
 NTSTATUS
 NTAPI
-MmCreateVirtualMapping(PEPROCESS Process,
+MmCreateVirtualMapping(PROS_EPROCESS Process,
                        PVOID Address,
                        ULONG flProtect,
                        PPFN_TYPE Pages,
@@ -1942,7 +1942,7 @@
 
 ULONG
 NTAPI
-MmGetPageProtect(PEPROCESS Process, PVOID Address)
+MmGetPageProtect(PROS_EPROCESS Process, PVOID Address)
 {
    ULONG Entry;
    ULONG Protect;
@@ -1988,7 +1988,7 @@
 
 VOID
 NTAPI
-MmSetPageProtect(PEPROCESS Process, PVOID Address, ULONG flProtect)
+MmSetPageProtect(PROS_EPROCESS Process, PVOID Address, ULONG flProtect)
 {
    ULONG Attributes = 0;
    BOOLEAN NoExecute = FALSE;
@@ -2273,7 +2273,7 @@
 
 VOID
 NTAPI
-MmUpdatePageDir(PEPROCESS Process, PVOID Address, ULONG Size)
+MmUpdatePageDir(PROS_EPROCESS Process, PVOID Address, ULONG Size)
 {
    ULONG StartOffset, EndOffset, Offset;
 
@@ -2307,7 +2307,7 @@
 	    EndOffset = 511;
 	 }
 
-         if (Process != NULL && Process != PsGetCurrentProcess())
+         if (Process != NULL && Process != (PROS_EPROCESS)PsGetCurrentProcess())
          {
             PageDirTable = MmCreateHyperspaceMapping(PAE_PTE_TO_PFN(Process->Pcb.DirectoryTableBase.QuadPart));
             Pde = (PULONGLONG)MmCreateHyperspaceMapping(PTE_TO_PFN(PageDirTable[i]));
@@ -2334,7 +2334,7 @@
       StartOffset = ADDR_TO_PDE_OFFSET(Address);
       EndOffset = ADDR_TO_PDE_OFFSET((PVOID)((ULONG_PTR)Address + Size));
 
-      if (Process != NULL && Process != PsGetCurrentProcess())
+      if (Process != NULL && Process != (PROS_EPROCESS)PsGetCurrentProcess())
       {
          Pde = MmCreateHyperspaceMapping(PTE_TO_PFN(Process->Pcb.DirectoryTableBase.u.LowPart));
       }
Index: ntoskrnl/mm/aspace.c
===================================================================
--- ntoskrnl/mm/aspace.c	(revision 21808)
+++ ntoskrnl/mm/aspace.c	(working copy)
@@ -64,7 +64,7 @@
 NTAPI
 MmGetCurrentAddressSpace(VOID)
 {
-   return(&PsGetCurrentProcess()->AddressSpace);
+   return(&((PROS_EPROCESS)PsGetCurrentProcess())->AddressSpace);
 }
 
 PMADDRESS_SPACE
@@ -76,7 +76,7 @@
 
 NTSTATUS
 NTAPI
-MmInitializeAddressSpace(PEPROCESS Process,
+MmInitializeAddressSpace(PROS_EPROCESS Process,
                          PMADDRESS_SPACE AddressSpace)
 {
    AddressSpace->MemoryAreaRoot = NULL;
Index: ntoskrnl/ex/profile.c
===================================================================
--- ntoskrnl/ex/profile.c	(revision 21808)
+++ ntoskrnl/ex/profile.c	(working copy)
@@ -45,14 +45,14 @@
     Profile = (PEPROFILE)ObjectBody;
 
     /* Check if there if the Profile was started */
-    if (Profile->LockedBuffer)
+    if (Profile->LockedBufferAddress)
     {
         /* Stop the Profile */
-        State = KeStopProfile(Profile->KeProfile);
+        State = KeStopProfile(Profile->ProfileObject);
         ASSERT(State != FALSE);
 
         /* Unmap the Locked Buffer */
-        MmUnmapLockedPages(Profile->LockedBuffer, Profile->Mdl);
+        MmUnmapLockedPages(Profile->LockedBufferAddress, Profile->Mdl);
         MmUnlockPages(Profile->Mdl);
         ExFreePool(Profile->Mdl);
     }
@@ -89,8 +89,8 @@
 NTAPI
 NtCreateProfile(OUT PHANDLE ProfileHandle,
                 IN HANDLE Process OPTIONAL,
-                IN PVOID ImageBase,
-                IN ULONG ImageSize,
+                IN PVOID RangeBase,
+                IN ULONG RangeSize,
                 IN ULONG BucketSize,
                 IN PVOID Buffer,
                 IN ULONG BufferSize,
@@ -110,17 +110,17 @@
     if(!BufferSize) return STATUS_INVALID_PARAMETER_7;
 
     /* Check if this is a low-memory profile */
-    if ((!BucketSize) && (ImageBase < (PVOID)(0x10000)))
+    if ((!BucketSize) && (RangeBase < (PVOID)(0x10000)))
     {
         /* Validate size */
         if (BufferSize < sizeof(ULONG)) return STATUS_INVALID_PARAMETER_7;
 
         /* This will become a segmented profile object */
-        Segment = (ULONG)ImageBase;
-        ImageBase = 0;
+        Segment = (ULONG)RangeBase;
+        RangeBase = 0;
 
         /* Recalculate the bucket size */
-        BucketSize = ImageSize / (BufferSize / sizeof(ULONG));
+        BucketSize = RangeSize / (BufferSize / sizeof(ULONG));
 
         /* Convert it to log2 */
         BucketSize--;
@@ -136,14 +136,14 @@
     }
 
     /* Make sure that the buckets can map the range */
-    if ((ImageSize >> (BucketSize - 2)) > BufferSize)
+    if ((RangeSize >> (BucketSize - 2)) > BufferSize)
     {
         DPRINT1("Bucket size too small\n");
         return STATUS_BUFFER_TOO_SMALL;
     }
 
     /* Make sure that the range isn't too gigantic */
-    if (((ULONG_PTR)ImageBase + ImageSize) < ImageSize)
+    if (((ULONG_PTR)RangeBase + RangeSize) < RangeSize)
     {
         DPRINT1("Range too big\n");
         return STATUS_BUFFER_OVERFLOW;
@@ -219,12 +219,12 @@
     if (!NT_SUCCESS(Status)) return(Status);
 
     /* Initialize it */
-    Profile->ImageBase = ImageBase;
-    Profile->ImageSize = ImageSize;
+    Profile->RangeBase = RangeBase;
+    Profile->RangeSize = RangeSize;
     Profile->Buffer = Buffer;
     Profile->BufferSize = BufferSize;
     Profile->BucketSize = BucketSize;
-    Profile->LockedBuffer = NULL;
+    Profile->LockedBufferAddress = NULL;
     Profile->Segment = Segment;
     Profile->ProfileSource = ProfileSource;
     Profile->Affinity = Affinity;
@@ -319,9 +319,9 @@
 NtStartProfile(IN HANDLE ProfileHandle)
 {
     PEPROFILE Profile;
-    PKPROFILE KeProfile;
+    PKPROFILE ProfileObject;
     KPROCESSOR_MODE PreviousMode = ExGetPreviousMode();
-    PVOID TempLockedBuffer;
+    PVOID TempLockedBufferAddress;
     NTSTATUS Status;
     PAGED_CODE();
 
@@ -342,7 +342,7 @@
                           NULL);
 
     /* The Profile can still be enabled though, so handle that */
-    if (Profile->LockedBuffer)
+    if (Profile->LockedBufferAddress)
     {
         /* Release our lock, dereference and return */
         KeReleaseMutex(&ExpProfileMutex, FALSE);
@@ -351,7 +351,7 @@
     }
 
     /* Allocate a Kernel Profile Object. */
-    KeProfile = ExAllocatePoolWithTag(NonPagedPool,
+    ProfileObject = ExAllocatePoolWithTag(NonPagedPool,
                                       sizeof(EPROFILE),
                                       TAG_PROFILE);
 
@@ -362,23 +362,23 @@
     MmProbeAndLockPages(Profile->Mdl, PreviousMode, IoWriteAccess);
 
     /* Map the pages */
-    TempLockedBuffer = MmMapLockedPages(Profile->Mdl, KernelMode);
+    TempLockedBufferAddress = MmMapLockedPages(Profile->Mdl, KernelMode);
 
     /* Initialize the Kernel Profile Object */
-    Profile->KeProfile = KeProfile;
-    KeInitializeProfile(KeProfile,
+    Profile->ProfileObject = ProfileObject;
+    KeInitializeProfile(ProfileObject,
                         (PKPROCESS)Profile->Process,
-                        Profile->ImageBase,
-                        Profile->ImageSize,
+                        Profile->RangeBase,
+                        Profile->RangeSize,
                         Profile->BucketSize,
                         Profile->ProfileSource,
                         Profile->Affinity);
 
     /* Start the Profiling */
-    KeStartProfile(KeProfile, TempLockedBuffer);
+    KeStartProfile(ProfileObject, TempLockedBufferAddress);
 
     /* Now it's safe to save this */
-    Profile->LockedBuffer = TempLockedBuffer;
+    Profile->LockedBufferAddress = TempLockedBufferAddress;
 
     /* Release mutex, dereference and return */
     KeReleaseMutex(&ExpProfileMutex, FALSE);
@@ -412,22 +412,22 @@
                           NULL);
 
     /* Make sure the Profile Object is really Started */
-    if (!Profile->LockedBuffer)
+    if (!Profile->LockedBufferAddress)
     {
         Status = STATUS_PROFILING_NOT_STARTED;
         goto Exit;
     }
 
     /* Stop the Profile */
-    KeStopProfile(Profile->KeProfile);
+    KeStopProfile(Profile->ProfileObject);
 
     /* Unlock the Buffer */
-    MmUnmapLockedPages(Profile->LockedBuffer, Profile->Mdl);
+    MmUnmapLockedPages(Profile->LockedBufferAddress, Profile->Mdl);
     MmUnlockPages(Profile->Mdl);
-    ExFreePool(Profile->KeProfile);
+    ExFreePool(Profile->ProfileObject);
 
     /* Clear the Locked Buffer pointer, meaning the Object is Stopped */
-    Profile->LockedBuffer = NULL;
+    Profile->LockedBufferAddress = NULL;
 
 Exit:
     /* Release Mutex, Dereference and Return */
Index: ntoskrnl/ex/init.c
===================================================================
--- ntoskrnl/ex/init.c	(revision 21808)
+++ ntoskrnl/ex/init.c	(working copy)
@@ -261,6 +261,7 @@
     ASSERT(FIELD_OFFSET(KPCR, Tib.ExceptionList) == KPCR_EXCEPTION_LIST);
     ASSERT(FIELD_OFFSET(KPCR, Self) == KPCR_SELF);
     ASSERT(FIELD_OFFSET(KIPCR, PrcbData) + FIELD_OFFSET(KPRCB, CurrentThread) == KPCR_CURRENT_THREAD);
+    DPRINT1("NPXThread offset: %lx\n", FIELD_OFFSET(KIPCR, PrcbData) + FIELD_OFFSET(KPRCB, NpxThread));
     ASSERT(FIELD_OFFSET(KIPCR, PrcbData) + FIELD_OFFSET(KPRCB, NpxThread) == KPCR_NPX_THREAD);
     ASSERT(FIELD_OFFSET(KTSS, Esp0) == KTSS_ESP0);
     ASSERT(FIELD_OFFSET(KTSS, IoMapBase) == KTSS_IOMAPBASE);
@@ -610,13 +611,13 @@
     ExpInitializeCallbacks();
 
     /* Call KD Providers at Phase 1 */
-    KdInitSystem(1, (PLOADER_PARAMETER_BLOCK)&KeLoaderBlock);
+    KdInitSystem(1, (PROS_LOADER_PARAMETER_BLOCK)&KeLoaderBlock);
 
     /* Initialize I/O Objects, Filesystems, Error Logging and Shutdown */
     IoInit();
 
     /* TBD */
-    PoInit((PLOADER_PARAMETER_BLOCK)&KeLoaderBlock, ForceAcpiDisable);
+    PoInit((PROS_LOADER_PARAMETER_BLOCK)&KeLoaderBlock, ForceAcpiDisable);
 
     /* Initialize the Registry (Hives are NOT yet loaded!) */
     CmInitializeRegistry();
@@ -640,7 +641,7 @@
     if (NoGuiBoot) ExpDisplayNotice();
 
     /* Call KD Providers at Phase 2 */
-    KdInitSystem(2, (PLOADER_PARAMETER_BLOCK)&KeLoaderBlock);
+    KdInitSystem(2, (PROS_LOADER_PARAMETER_BLOCK)&KeLoaderBlock);
 
     /* Import and create NLS Data and Sections */
     RtlpInitNls();
Index: ntoskrnl/ex/win32k.c
===================================================================
--- ntoskrnl/ex/win32k.c	(revision 21808)
+++ ntoskrnl/ex/win32k.c	(working copy)
@@ -36,10 +36,10 @@
 };
 
 OB_OPEN_METHOD ExpWindowStationObjectOpen = NULL;
-OB_PARSE_METHOD ExpWindowStationObjectParse = NULL;
+OB_ROS_PARSE_METHOD ExpWindowStationObjectParse = NULL;
 OB_DELETE_METHOD ExpWindowStationObjectDelete = NULL;
-OB_FIND_METHOD ExpWindowStationObjectFind = NULL;
-OB_CREATE_METHOD ExpDesktopObjectCreate = NULL;
+OB_ROS_FIND_METHOD ExpWindowStationObjectFind = NULL;
+OB_ROS_CREATE_METHOD ExpDesktopObjectCreate = NULL;
 OB_DELETE_METHOD ExpDesktopObjectDelete = NULL;
 
 /* FUNCTIONS ****************************************************************/
@@ -133,9 +133,9 @@
     ObjectTypeInitializer.Length = sizeof(ObjectTypeInitializer);
     ObjectTypeInitializer.GenericMapping = ExpWindowStationMapping;
     ObjectTypeInitializer.PoolType = NonPagedPool;
-    ObjectTypeInitializer.OpenProcedure = ExpWinStaObjectOpen;
+    ObjectTypeInitializer.OpenProcedure = (OB_OPEN_METHOD)ExpWinStaObjectOpen;
     ObjectTypeInitializer.DeleteProcedure = ExpWinStaObjectDelete;
-    ObjectTypeInitializer.ParseProcedure = ExpWinStaObjectParse;
+    ObjectTypeInitializer.ParseProcedure = (OB_PARSE_METHOD)ExpWinStaObjectParse;
     ObpCreateTypeObject(&ObjectTypeInitializer,
                         &Name,
                         &ExWindowStationObjectType);
Index: ntoskrnl/ex/dbgctrl.c
===================================================================
--- ntoskrnl/ex/dbgctrl.c	(revision 21808)
+++ ntoskrnl/ex/dbgctrl.c	(working copy)
@@ -17,7 +17,7 @@
 
 NTSTATUS
 STDCALL
-NtSystemDebugControl(DEBUG_CONTROL_CODE ControlCode,
+NtSystemDebugControl(SYSDBG_COMMAND ControlCode,
                      PVOID InputBuffer,
                      ULONG InputBufferLength,
                      PVOID OutputBuffer,
@@ -26,15 +26,15 @@
 {
     switch (ControlCode)
     {
-        case DebugGetTraceInformation:
-        case DebugSetInternalBreakpoint:
-        case DebugSetSpecialCall:
-        case DebugClearSpecialCalls:
-        case DebugQuerySpecialCalls:
-        case DebugDbgBreakPoint:
+        case SysDbgQueryTraceInformation:
+        case SysDbgSetTracepoint:
+        case SysDbgSetSpecialCall:
+        case SysDbgClearSpecialCalls:
+        case SysDbgQuerySpecialCalls:
+        case SysDbgBreakPoint:
             break;
 
-        case DebugDbgLoadSymbols:
+        case SysDbgQueryVersion:
             KDB_LOADUSERMODULE_HOOK((PLDR_DATA_TABLE_ENTRY) InputBuffer);
             break;
 
Index: ntoskrnl/ex/sysinfo.c
===================================================================
--- ntoskrnl/ex/sysinfo.c	(revision 21808)
+++ ntoskrnl/ex/sysinfo.c	(working copy)
@@ -581,11 +581,12 @@
 		do
 		{
 			PSYSTEM_PROCESS_INFORMATION SpiCur;
-			int curSize, i = 0;
+			int curSize;
 			ANSI_STRING	imgName;
 			int inLen=32; // image name len in bytes
 			PLIST_ENTRY current_entry;
 			PETHREAD current;
+            PSYSTEM_THREAD_INFORMATION ThreadInfo;
 
 			SpiCur = (PSYSTEM_PROCESS_INFORMATION)pCur;
 
@@ -645,7 +646,8 @@
 			SpiCur->QuotaNonPagedPoolUsage = pr->QuotaUsage[1];
 			SpiCur->PagefileUsage = pr->QuotaUsage[3];
 			SpiCur->PeakPagefileUsage = pr->QuotaPeak[3];
-			SpiCur->PrivateUsage = pr->CommitCharge;
+			SpiCur->PrivatePageCount = pr->CommitCharge;
+            ThreadInfo = (PSYSTEM_THREAD_INFORMATION)(SpiCur + 1);
 
 		        current_entry = pr->ThreadListHead.Flink;
         		while (current_entry != &pr->ThreadListHead)
@@ -653,18 +655,19 @@
 				current = CONTAINING_RECORD(current_entry, ETHREAD,
 				                            ThreadListEntry);
 
-				SpiCur->TH[i].KernelTime.QuadPart = current->Tcb.KernelTime * 100000LL;
-				SpiCur->TH[i].UserTime.QuadPart = current->Tcb.UserTime * 100000LL;
+                
+				ThreadInfo->KernelTime.QuadPart = current->Tcb.KernelTime * 100000LL;
+				ThreadInfo->UserTime.QuadPart = current->Tcb.UserTime * 100000LL;
 //				SpiCur->TH[i].CreateTime = current->CreateTime;
-				SpiCur->TH[i].WaitTime = current->Tcb.WaitTime;
-				SpiCur->TH[i].StartAddress = (PVOID) current->StartAddress;
-				SpiCur->TH[i].ClientId = current->Cid;
-				SpiCur->TH[i].Priority = current->Tcb.Priority;
-				SpiCur->TH[i].BasePriority = current->Tcb.BasePriority;
-				SpiCur->TH[i].ContextSwitches = current->Tcb.ContextSwitches;
-				SpiCur->TH[i].ThreadState = current->Tcb.State;
-				SpiCur->TH[i].WaitReason = current->Tcb.WaitReason;
-				i++;
+				ThreadInfo->WaitTime = current->Tcb.WaitTime;
+				ThreadInfo->StartAddress = (PVOID) current->StartAddress;
+				ThreadInfo->ClientId = current->Cid;
+				ThreadInfo->Priority = current->Tcb.Priority;
+				ThreadInfo->BasePriority = current->Tcb.BasePriority;
+				ThreadInfo->ContextSwitches = current->Tcb.ContextSwitches;
+				ThreadInfo->ThreadState = current->Tcb.State;
+				ThreadInfo->WaitReason = current->Tcb.WaitReason;
+				ThreadInfo++;
 				current_entry = current_entry->Flink;
 			}
 
@@ -986,15 +989,15 @@
 /* Class 21 - File Cache Information */
 QSI_DEF(SystemFileCacheInformation)
 {
-	SYSTEM_CACHE_INFORMATION *Sci = (SYSTEM_CACHE_INFORMATION *) Buffer;
+	SYSTEM_FILECACHE_INFORMATION *Sci = (SYSTEM_FILECACHE_INFORMATION *) Buffer;
 
-	if (Size < sizeof (SYSTEM_CACHE_INFORMATION))
+	if (Size < sizeof (SYSTEM_FILECACHE_INFORMATION))
 	{
-		* ReqSize = sizeof (SYSTEM_CACHE_INFORMATION);
+		* ReqSize = sizeof (SYSTEM_FILECACHE_INFORMATION);
 		return (STATUS_INFO_LENGTH_MISMATCH);
 	}
 
-	RtlZeroMemory(Sci, sizeof(SYSTEM_CACHE_INFORMATION));
+	RtlZeroMemory(Sci, sizeof(SYSTEM_FILECACHE_INFORMATION));
 
 	/* Return the Byte size not the page size. */
 	Sci->CurrentSize =
@@ -1011,7 +1014,7 @@
 
 SSI_DEF(SystemFileCacheInformation)
 {
-	if (Size < sizeof (SYSTEM_CACHE_INFORMATION))
+	if (Size < sizeof (SYSTEM_FILECACHE_INFORMATION))
 	{
 		return (STATUS_INFO_LENGTH_MISMATCH);
 	}
@@ -1545,7 +1548,7 @@
       /*
        * Check the request is valid.
        */
-      if (SystemInformationClass >= SystemInformationClassMax)
+      if (SystemInformationClass >= MaxSystemInfoClass)
         {
           return (STATUS_INVALID_INFO_CLASS);
         }
@@ -1621,7 +1624,7 @@
 	 * Check the request is valid.
 	 */
 	if (	(SystemInformationClass >= SystemBasicInformation)
-		&& (SystemInformationClass < SystemInformationClassMax)
+		&& (SystemInformationClass < MaxSystemInfoClass)
 		)
 	{
 		if (NULL != CallQS [SystemInformationClass].Set)
